Attribute VB_Name = "modStringToBit05"
Option Explicit

' by Paul - wpsjr1@syix.com
' http://www.syix.com/wpsjr1/index.html

Private lookup(0 To 15) As Currency

Public Function StringToBit05(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011026
  Dim lLen             As Long
  Dim i                As Long
  Dim bTemp            As Byte
  Static b()           As Byte
  Static cOut()        As Currency
  Static lInit         As Long
  Static lLastLen      As Long
  
  lLen = Len(sData)
  If lLen Then
    If lInit Then
    Else
      lInit = 1
      InitLookupTable
    End If

    If lLastLen <> lLen Then
      ReDim b(lLen)
      ReDim cOut(lLen * 2)
    End If
    lLastLen = lLen
    
    FastString.WideCharToMultiByte 0&, 0&, sData, lLen, b(0), lLen, 0&, 0&
    
    For i = 0 To lLen - 1
      bTemp = b(i)
      cOut(i * 2) = lookup(bTemp \ &H10)
      cOut((i * 2) + 1) = lookup(bTemp And &HF)
    Next i
    
    StringToBit05 = FastString.SysAllocStringLen(cOut(0), lLen * 8)
  End If
End Function

Public Function StringToBitB05(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011027
  Dim lInArrayPointer  As Long
  Static cOut()        As Currency
  Dim lLen             As Long
  Dim i                As Long
  Static iData()       As Integer           ' array shell used to contain string data
  Dim saIn             As SAFEARRAYHEADER
  Static lInit         As Long
  Static lLastLen      As Long
  Dim iTemp            As Integer
  
  lLen = Len(sData)
  If lLen Then                              ' not zero length
    lInArrayPointer = VarPtrArray(iData)
    If RedimArray(integerArray, lLen, saIn, StrPtr(sData), lInArrayPointer) Then
      If lInit Then
      Else
        lInit = 1
        InitLookupTable
      End If
       
      If lLastLen <> lLen Then ReDim cOut(lLen * 2) ' one extra, but don't bother subtracting
      lLastLen = lLen
      
      For i = 0 To lLen - 1
        iTemp = iData(i)
        cOut(i * 2) = lookup((iTemp And &HF0) \ &H10)
        cOut((i * 2) + 1) = lookup(iTemp And &HF)
      Next i
      StringToBitB05 = FastString.SysAllocStringLen(cOut(0), lLen * 8)
      DestroyArray lInArrayPointer
    End If
  End If
End Function

Public Function StringToBitW05(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011027
  Dim lInArrayPointer  As Long
  Static cOut()        As Currency
  Dim lLen             As Long
  Dim i                As Long
  Static iData()       As Integer           ' array shell used to contain string data
  Dim saIn             As SAFEARRAYHEADER
  Static lInit         As Long
  Static lLastLen      As Long
  Dim iTemp            As Integer
  
  lLen = Len(sData)
  If lLen Then                              ' not zero length
    lInArrayPointer = VarPtrArray(iData)
    If RedimArray(integerArray, lLen, saIn, StrPtr(sData), lInArrayPointer) Then
      If lInit Then
      Else
        lInit = 1
        InitLookupTable
      End If
      
      If lLastLen <> lLen Then ReDim cOut(lLen * 4) ' one extra, but don't bother subtracting
      lLastLen = lLen
      
      For i = 0 To lLen - 1
        iTemp = iData(i)
        cOut(i * 4) = lookup((iTemp And &HF000&) \ &H1000)
        cOut((i * 4) + 1) = lookup((iTemp And &HF00&) \ &H100)
        cOut((i * 4) + 2) = lookup((iTemp And &HF0) \ &H10)
        cOut((i * 4) + 3) = lookup(iTemp And &HF)
      Next i
      StringToBitW05 = FastString.SysAllocStringLen(cOut(0), lLen * 16)
      DestroyArray lInArrayPointer
    End If
  End If
End Function

Private Sub InitLookupTable()
  lookup(0) = 1351100504368.7472@ ' magic numbers, magical mystery tour :P
  lookup(1) = 1379248002039.8128@
  lookup(2) = 1351100933865.4768@
  lookup(3) = 1379248431536.5424@
  lookup(4) = 1351100504375.3008@
  lookup(5) = 1379248002046.3664@
  lookup(6) = 1351100933872.0304@
  lookup(7) = 1379248431543.096@
  lookup(8) = 1351100504368.7473@
  lookup(9) = 1379248002039.8129@
  lookup(10) = 1351100933865.4769@
  lookup(11) = 1379248431536.5425@
  lookup(12) = 1351100504375.3009@
  lookup(13) = 1379248002046.3665@
  lookup(14) = 1351100933872.0305@
  lookup(15) = 1379248431543.0961@
End Sub
